#pragma once

#include <Arduino.h>
#include <map>
#include <string>

struct IconData {
    uint8_t* data;
    uint width;
    uint height;
};

class IconManager {
public:
    static void loadIcon(const char* name, const unsigned char* compressedData, size_t compressedSize, size_t originalSize, uint width, uint height);
    static void unloadIcon(const char* name);
    static IconData* getIcon(const char* name);
    static void cleanup();

private:
    static std::map<std::string, IconData> loadedIcons;
}; 